<template>
  <div
    id="swipewindow"
    class="modalwindow">
    <div class="windowcontent">
      <div
        v-show="showSwipeCard"
        class="swiperready">
        Please swipe your debit card.
      </div>
      <input
        id="rawAccountId"
        ref="rawAccountId"
        v-model="accountId"
        style="border: 0; color: white; outline: none !important; box-shadow: none !important;
        margin-bottom: .5em; padding: 0px;"
        @keypress.enter="validateAccountId">
      <div
        v-if="cardReading"
        class="swipewait">
        Please wait!<br>
        Your card is being read.
      </div>
      <div
        v-show="showManualTransactionButton"
        class="manual-entry">
        <input
          type="button"
          name="ManualEntry"
          value="Enter Card Manually"
          style="font-size: 2.8rem; color: white; line-height: 33px;background: #68b502 none repeat scroll 0 0; width: auto;box-shadow: 0 0 0 0.3rem #c1e88e; border-radius: 2rem; display: inline-block; padding: 0.5rem 2rem 0.7rem text-decoration: none; margin-right: 20px"
          @click="manualTransaction = true; showManualTransactionButton = false; showSwipeCard = false">
      </div>
      <div
        v-show="manualTransaction"
        class="manual-login">
        <p style="color: #69b9f2; font-family: Mouse Memoirs; font-size: 34px; line-height: 44px;" >Enter last three digits of debit card number:</p>
        <input
          v-model="accountId"
          autofocus="true"
          type="text"
          name="ManualID"
          style="font-size: 4.0rem; line-height: 33px;"
          @keypress.enter="validateAccountId"
        >
        <input
          type="button"
          name="ManualConfirm"
          value="Enter"
          style="font-size: 2.8rem; color: white; line-height: 33px; background: #68b502 none repeat scroll 0 0; width: auto; box-shadow: 0 0 0 0.3rem #c1e88e; border-radius: 2rem;display: inline-block; padding: 0.5rem 2rem 0.7rem;text-decoration: none; margin-right: 20px"
          @click="validateAccountId" >
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      cardReading: false,
      showSwipeCard: true,
      showManualTransactionButton: true,
      manualTransaction: false,
      accountId: "",
      account: ""
    };
  },
  methods: {
    validateAccountId() {
      if(!this.accountId) {
        app.Message("Please swipe or enter your card again.", "error");
        // for manual entry
      } else if (this.accountId.length === 3) {
        this.getAccount();
        // this.accountId = null;
        //length of debit card data exactly
      } else if (this.accountId.length === 18) {
        // this.showManualTransactionButton = false;
        // this.showSwipeCard = false;
        this.accountId = this.accountId.substring(14,17);
        this.getAccount();
        // this.accountId = null;
      } else {
        app.Message("Please swipe or enter your card again.", "error");
        this.accountId = null;
      }
    },
    getAccount() {
      app.api.Get(`accounts/${this.accountId}`)
        .then( response => {
          if (response.status === "no account found") {
            app.Message("Sorry, the entered account number was not found. Please try again.", "warn");
          } else {
            this.account = response;
            this.$emit("authenticated", this.account);
          }
        });
    },
  },
};
</script>